Index: s390-tools-sles11/iucvterm/bin/ts-shell.in
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/bin/ts-shell.in
@@ -0,0 +1,669 @@
+#! /usr/bin/perl -W
+#
+# ts-shell - Simple terminal server shell to access systems over IUCV
+#
+# This script can be used as login shell for users to restrict
+# IUCV-based terminal access to other systems.
+#
+# Copyright IBM Corp. 2008, 2009.
+# Author: Hendrik Brueckner <brueckner@linux.vnet.ibm.com>
+#
+use strict;
+use warnings;
+use File::Basename;
+use Getopt::Long qw(:config no_ignore_case);
+use Term::ReadLine;
+use POSIX;
+
+
+$ENV{'PERL_RL'} = " o=0";   # use best avail. readline
+$ENV{'PATH'} = "/bin:/sbin:/usr/bin:/usr/sbin";
+$ENV{'LESSSECURE'} = 1;     # let less run in "secure" mode
+$ENV{'PAGER'} = $ENV{'PAGER'} || "/usr/bin/less";
+my $ts_shell = fileparse($0, qr/\.[^.]+/);
+$SIG{__WARN__} = sub { print STDERR "$ts_shell: $_[0]"; };
+$SIG{__DIE__}  = sub { print STDERR "$ts_shell: $_[0]"; exit 255; };
+
+# Terminal server configuration settings
+my %config = (
+	# general options
+	'conffile'	=>	"@sysconf_path@/ts-shell.conf",
+	'authfile'	=>	"@sysconf_path@/ts-authorization.conf",
+	'sysfile'	=>	"@sysconf_path@/ts-systems.conf",
+	'auditfile'	=>	"@sysconf_path@/ts-logsys.conf",
+	'auditdir'	=>	"/var/log/ts-shell",
+	'iucvconn'	=>	"@iucvconn_path@/iucvconn",
+	'prompt'	=>	getpwuid($>) . '@'."$ts_shell> ",
+	# runtime options
+	'rl'		=>	undef,		# terminal readline (rl)
+	'user'		=>	getpwuid($>),	# user name
+	'groups'	=>	[],		# user groups (list ref)
+	'service'	=>	"lnxhvc0",	# default service
+	'auth_func'	=>	sub { return -1; },	# no authorization
+	'regex'		=>	[],		# re to match systems (list ref)
+	'systems'	=>	[],		# system list (list reference)
+	'services'      =>      [qw/lnxhvc0/],	# services list (completion)
+	'termsys'	=>	{},		# global ts sys list (hash ref)
+	'auditsys'	=>	{},		# audit ts sys list (hash ref)
+);
+
+
+sub main();
+sub help();
+sub usage();
+sub version();
+sub intro();
+sub auth_global($$);
+sub auth_regex($$);
+sub auth_list($$);
+sub get_auditlog_file($$$);
+sub cmd_connect($\%);
+sub cmd_service($\%);
+sub cmd_list(\%);
+sub rl_cmd_completion($$$);
+sub list_regex_match($);
+sub updateConfiguration(\%$);
+sub loadAuthorization(\%);
+sub readFile($$);
+sub log_debug($);
+sub log_error($);
+sub log_info($);
+sub pager($);
+
+
+# main() - Terminal server program
+#
+# The program loads the system authorizations for the effective user id,
+# and then initializes the term readline environment and starts the shell.
+#
+sub main()
+{
+	unless (GetOptions("v|version" => sub { version(); exit 0; },
+	 		   "h|help"    => sub { usage();   exit 0; })) {
+		log_error "Enter '$ts_shell --help' for more information";
+		exit 1;
+	}
+
+	unless (-t STDIN) {
+		log_error "The $ts_shell requires a terminal to run on";
+		exit 1;
+	}
+
+	unless ($config{user}) {
+		log_error "Resolving the name of user ID $> failed";
+		exit 2;
+	}
+
+	# update ts-shell configuration
+	unless (readFile($config{conffile},
+			sub { updateConfiguration(%config, $_); })) {
+		log_error "Reading the ts-shell configuration file " .
+			  "$config{conffile} failed: $!";
+		exit 3;
+	}
+
+	# load list of systems the ts-shell is allowed to use; and
+	# hash the systems names in uppercase
+	unless (readFile($config{sysfile},
+			 sub { $config{termsys}->{uc $_} = 1; })) {
+		log_error "Reading $config{sysfile} failed: $!";
+		exit 4;
+	}
+
+	# load list of systems for for that auditing should be enabled
+	# hash the system names in uppercase
+	unless (readFile($config{auditfile},
+			 sub { $config{auditsys}->{uc $_} = 1; })) {
+		log_error "Reading $config{auditsys} failed: $!";
+		exit 5;
+	}
+
+	# retrieve user group membership and load authorizations
+	my %uniq_groups = ();
+	# $) returns egid twice, so we hash group names to avoid dups
+	foreach(map {$_ = getgrgid($_)} split / /, $)) {
+		$uniq_groups{$_} = 1;
+	}
+	push @{$config{groups}}, keys %uniq_groups;
+
+	# finally, load user specific authorization data from file
+	unless (loadAuthorization(%config)) {
+		log_error "Reading $config{authfile} failed: $!";
+		exit 5;
+	}
+
+	# set up terminal readline
+	$config{rl} = new Term::ReadLine 'Terminal Server Shell';
+	$config{rl}->Attribs->{'completion_function'} = \&rl_cmd_completion;
+	select ($config{rl}->OUT || \*STDOUT);
+
+	# setup signal handler to ignore SIGINT
+	my $sigint = POSIX::SigAction->new(sub { return 1; },
+					   POSIX::SigSet->new(),
+					   &POSIX::SA_NODEFER);
+	POSIX::sigaction(&POSIX::SIGINT, $sigint);
+
+	log_debug "User: $config{user} / Groups: $) [@{$config{groups}}]";
+	log_debug("Using Term::ReadLine backend: " . $config{rl}->ReadLine);
+
+	intro();
+	SHELL: while (defined($_ = $config{rl}->readline($config{prompt}))) {
+		chomp;
+		s/^\s+|\s+$//;
+		next if /^$/;
+		SWITCH: {
+			/^(?:q|quit|exit)/  and last SHELL;
+			/^help/		    and help(), last SWITCH;
+			/^version/	    and version(), last SWITCH;
+			/^(?:list|ls)/	    and cmd_list(%config), last SWITCH;
+			/^terminal\s*(\w*)/ and cmd_service($1, %config), last SWITCH;
+
+			if (/^connect\s*(\w*$|\w+\s+\w+)/) {
+				cmd_connect($1, %config);
+				last SWITCH;
+			}
+
+			log_error "$_ is not a known command";
+		}
+		$config{rl}->addhistory($_)
+			if (/\S/ && !$config{rl}->Features->{autohistory});
+	}
+	exit 0;
+}
+
+# updateConfiguration() - Load ts-shell configuration from ts-shell.conf
+#
+# %cfg:		Hash reference to terminal server configuration
+# $line:	Configuration line (key = value pair)
+#
+# The routine updates the ts-shell configuration based on configuration lines
+# from the ts-shell.conf file.
+#
+sub updateConfiguration(\%$)
+{
+	my ($cfg, $line) = @_;
+	my ($option, $value) = split /\s*=\s*/, $line;
+
+	$cfg->{sysfile}   = $value if $option =~ /^ts-systems$/;
+	$cfg->{authfile}  = $value if $option =~ /^ts-authorization$/;
+	$cfg->{auditdir}  = $value if $option =~ /^transcript-directory$/;
+	$cfg->{auditfile} = $value if $option =~ /^transcript-systems$/;
+}
+
+# loadAuthorization() - Load system authorizations from file
+#
+# $cfg:		Hash reference to terminal server configuration
+#
+# The routine parses the authorization data for the effective user
+# and stores the information in the configuration hash. Further, it
+# sets the auth_func reference to either auth_list() or auth_regex()
+# to abstract authorization checks.
+#
+sub loadAuthorization(\%)
+{
+	my $cfg = shift();
+
+	return 0 unless open(AUTH, "<$cfg->{authfile}");
+
+	AUTH_ENT: while (<AUTH>) {
+		chomp;
+		next if /^#/;		# ignore comments
+		next if /^\s*$/;	# skip empty lines
+		s/^\s+|\s+$//g;		# trim
+
+		my $authorized = 0;
+		my ($key, $val) = split /\s*=\s*/;
+
+		# read authorization configuration for user and its groups
+		if ($key =~ /^$cfg->{user}$/) {
+			$authorized = 1;
+			log_debug "Found user: $key";
+
+		} elsif ($key =~ /^@(\w+)$/) {
+			my $group = $1;
+			$authorized = 1 if grep {/^${group}$/} @{$cfg->{groups}};
+			log_debug "Found group: $key" if $authorized;
+		}
+
+		# skip line if there was no auth data for current user
+		next unless $authorized;
+
+		# build authorization policy and set auth_func
+		if ($val =~ /^list:\s*(.+)$/) {
+			if (@{$cfg->{regex}}) {
+				log_error "Authorization by list is ignored because "
+					  ."$cfg->{user} uses regular expressions "
+					  ."($cfg->{authfile}:$.)";
+				next AUTH_ENT;
+			}
+
+			$cfg->{auth_func} = \&auth_list;
+			push @{$cfg->{systems}}, split /\s*[;,]\s*/, $1;
+
+		} elsif ($val =~ /^file:(.+)$/) {
+			if (@{$cfg->{regex}}) {
+				log_error "Authorization by list is ignored because "
+					. "$cfg->{user} uses regular expressions "
+					. "($cfg->{authfile}:$.)";
+				next AUTH_ENT;
+			}
+
+			$cfg->{auth_func} = \&auth_list;
+			unless(readFile($1, sub { push @{$cfg->{systems}}, $_; })) {
+				log_error "Reading $1 failed: $! "
+					. "($cfg->{authfile}:$.)";
+			}
+		} elsif ($val =~ /^regex:(.+)$/) {
+			if (@{$cfg->{systems}}) {
+				log_error "Authorization by regular expression "
+					. "is ignored because $cfg->{user} "
+					. "uses lists ($cfg->{authfile}:$.)";
+				next AUTH_ENT;
+			}
+
+			# check regex syntax and complain if it is not correct
+			my $re = eval "qr/$1/io";
+			if ($@) {
+				log_error "An authorization entry is not a valid"
+					. " regular expression "
+					. "($cfg->{authfile}:$.):\n$@";
+				next AUTH_ENT;
+			}
+
+			$cfg->{auth_func} = \&auth_regex;
+			push @{$cfg->{regex}}, $re;
+
+		} else {
+			log_error "An authorization entry is not valid "
+				. "($cfg->{authfile}:$.)";
+		}
+		log_debug "'$key' => '$val'";
+	}
+	close(AUTH);
+
+	return 1;
+}
+
+# readFile() - Helper routine to read data from file
+#
+# The routine reads the file content, line by line, skips
+# comments and empty lines. It calls a routine for each line
+# containing data. The routine can access the data either
+# using the first parameter or using the context variable $_.
+#
+# Error handling is up to the caller; the routine exits with
+# zero if the file could not be opened. open() should set $!.
+#
+# $file:	File name
+# $sub:		Reference to sub routine
+#
+sub readFile($$)
+{
+	my ($file, $sub) = @_;
+
+	return 0 unless open(CONF, "<$file");
+	while (<CONF>) {
+		chomp;
+		next if /^#/;		# ignore comments
+		next if /^\s*$/;	# skip empty lines
+		s/^\s+|\s+$//g;		# trim
+		&{$sub}($_);		# execute sub in current context
+	}
+	close(CONF);
+	return 1;
+}
+
+# auth_global() - Authorization check using global system list
+#
+# $guest:	Scalar reference to the guest name string
+# $cfg:         Hash reference to terminal server configuration
+#
+sub auth_global($$)
+{
+	my ($guest, $cfg) = @_;
+
+	return -1 unless $cfg->{termsys};
+
+	# unstricted
+	return  1 if exists $cfg->{termsys}->{'[*ALL*]'};
+	# if restricted, check if system has been hashed (in uppercase)
+	return  1 if exists $cfg->{termsys}->{uc $$guest};
+
+	# guest has not been defined, so deny authorization request
+	return -2;
+}
+
+# auth_regex() - Authorization check using a regex
+#
+# $guest:	Scalar reference to the guest name string
+# $cfg:		Hash reference to terminal server configuration
+#
+sub auth_regex($$)
+{
+	my ($guest, $cfg) = @_;
+
+	return -1 unless @{$cfg->{regex}};
+	foreach my $re (@{$cfg->{regex}}) {
+		return 1 if $$guest =~ /$re/; # $re has been compiled as //io
+	}
+	return  0;
+}
+
+# auth_list() - Authorization check using a list of systems
+#
+# $guest:	Scalar reference to the guest name string
+# $cfg:		Hash reference to terminal server configuration
+#
+sub auth_list($$)
+{
+	my ($guest, $cfg) = @_;
+
+	return -1 unless @{$cfg->{systems}};
+	return 1 if grep(/^\s*\Q$$guest\E\s*$/i, @{$cfg->{systems}});
+	return 0;
+}
+
+# get_auditlog_file() - Set file path for session transcript
+#
+# Return false if an error has occured; otherwise true.
+#
+# $filepath:	Scalar reference to file path variable
+# $guest:	Name of the virtual guest machine
+# $cfg:		Hash reference to terminal server configuration
+sub get_auditlog_file($$$)
+{
+	my ($filepath, $guest, $cfg) = @_;
+
+	unless (exists $cfg->{auditsys}->{'[*ALL*]'} ||
+	     	exists $cfg->{auditsys}->{uc $guest}) {
+		$$filepath = "";
+		return 1;		# no transcript, return success
+	}
+
+	# check and create log directory for user
+	unless (-d "$cfg->{auditdir}/$cfg->{user}") {
+		unless (mkdir "$cfg->{auditdir}/$cfg->{user}") {
+			log_error "Creating the session transcript directory "
+				. "$cfg->{auditdir}/$cfg->{user} failed: $!";
+			$$filepath = "";
+			return 0;	# return error
+		}
+	}
+
+	$$filepath  = "$cfg->{auditdir}/$cfg->{user}/" . uc $guest . "_";
+	$$filepath .= strftime '%F-%H%M%S', localtime;
+
+	log_debug "Session transcript file: $$filepath";
+
+	return 1;			# return success
+}
+
+# cmd_connect() - Perform auth check; and on success, connect to system
+#
+# $guest:	Name of the virtual guest machine
+# $cfg:		Hash reference to terminal server configuration
+#
+sub cmd_connect($\%)
+{
+	my ($params, $cfg) = @_;
+	my $service        = $cfg->{service};
+
+	unless (length($params)) {
+		log_error "The z/VM guest name is missing";
+		return;
+	}
+
+	my ($guest, $srv) = split /\s+/, $params;
+	$service = $srv if $srv && $srv =~ /\w{1,8}/;
+
+	# check authorization:
+	# The auth_func contract is to return a code, that must be one of:
+	#	-2:	ts-shell is not permitted to connect to the guest
+	#	-1:	The user does not have any authorization policy
+	#	 0:	User does not have authorization to connect to guest
+	#	 1:	User is permitted to connect to guest (success)
+	# Other return codes are not allowed!
+	#
+	# call auth_func to check authorization
+	my  $rc = &{$cfg->{auth_func}}(\$guest, $cfg);
+
+	# if the user is authorized, finally check if the system is
+	# (globally) restricted to be used by the terminal server
+	$rc = auth_global(\$guest, $cfg) if $rc > 0;
+
+	if ($rc == -2) {
+		log_error "$ts_shell is not configured to connect to $guest";
+		return;
+	}
+	if ($rc == -1) {
+		log_error "You are not authorized to connect to "
+			. "any z/VM virtual machines";
+		return;
+	}
+	if ($rc == 0) {
+		log_error "You are not authorized to connect to $guest";
+		return;
+	}
+
+	# construct iucvconn command line
+	my @iucvconn = ("$cfg->{iucvconn}");
+
+	# check if the terminal session to $guest requires session logging
+	my $session_path = "";
+	# return if get_auditlog_file() failed
+	return unless get_auditlog_file(\$session_path, $guest, $cfg);
+	push @iucvconn, "-s", $session_path if $session_path;
+
+	# add $guest name and terminal identifier (service)
+	push @iucvconn, $guest, $service;
+
+	log_info "Connecting to $guest (terminal identifier: $service)...";
+	if (-x $cfg->{iucvconn}) {
+		system @iucvconn;
+		log_info "Connection ended";
+	} else {
+		log_error "Running $cfg->{iucvconn} failed: $!";
+	}
+}
+
+# cmd_service() - Show / set service/terminal name to identify remote terminal
+#
+# $new:		New terminal name; can be empty
+# %cfg:		Hash reference to terminal server configuration
+#
+sub cmd_service($\%)
+{
+	my ($new, $cfg) = @_;
+
+	unless ($new) {
+		print "$cfg->{service}\n";
+		return;
+	}
+
+	if ($new =~ /\w{1,8}/) {
+		$cfg->{service} = $new;
+		# push new service for cmd completion
+		unless (grep /$new/, @{$cfg->{services}}) {
+			push @{$cfg->{services}}, $new;
+		}
+	} else {
+		log_error("Terminal identifier $new is not valid");
+		log_error("Terminal identifiers consist of up to " .
+			  "eight alphanumerical characters");
+	}
+}
+
+# cmd_list() - List system authorization for effective user
+#
+# $cfg:		Hash reference to terminal server configuration
+#
+sub cmd_list(\%)
+{
+	my $cfg = shift();
+
+	if (@{$cfg->{regex}}) {
+		pager sub {
+			print "Regular expressions for your authorization:\n";
+			print "$_\n" foreach (@{$cfg->{regex}});
+			my $matches = list_regex_match($cfg);
+			if (@$matches) {
+				print "\nYou are authorized to connect to ".
+				      "these z/VM guest virtual machines:\n";
+				print "$_\n" foreach (@$matches);
+			}
+		};
+	} elsif (@{$cfg->{systems}}) {
+		pager sub {
+			foreach (@{$cfg->{systems}}) {
+				printf "$_\n" if auth_global(\$_, $cfg) > 0;
+			}
+		};
+	} else {
+		log_error "You are not authorized to connect to " .
+			  "any z/VM virtual machines";
+	}
+}
+
+sub log_debug($)
+{
+	print STDERR "[DEBUG] " . shift() . "\n" if $ENV{'TS_SHELL_DEBUG'};
+}
+
+sub log_error($)
+{
+	print STDERR "$ts_shell: " . shift() . "\n";
+}
+
+sub log_info($)
+{
+	print "$ts_shell: " . shift() . "\n";
+}
+
+sub pager($)
+{
+	my $eval = shift();
+
+	unless (open(PAGER, "|$ENV{'PAGER'}")) {
+		eval &$eval;
+		return;
+	}
+	my $old_out = select PAGER;
+	eval &$eval;
+	select $old_out;
+	close (PAGER);
+}
+
+sub intro()
+{
+  print <<EoIntro;
+Welcome to the Terminal Server shell.
+Type 'help' to get a list of available commands.
+
+
+EoIntro
+}
+
+sub version()
+{
+	print <<EoVersion
+Terminal Server Shell, version @S390_TOOLS_RELEASE@
+Copyright IBM Corp. 2008, 2009
+
+EoVersion
+}
+
+sub help()
+{
+	print STDERR <<EoHelp;
+Terminal Server shell help
+
+Available commands:
+	list			List authorizations.
+	connect <vm_guest>	Connect to specified z/VM guest virtual machine.
+	terminal [<identifier>]	Display or set the terminal identifier.
+	q | quit | exit		Exit the current shell session.
+	help			Display help information.
+	version			Display version information.
+
+EoHelp
+}
+
+sub usage()
+{
+	printf <<EoUsage;
+Usage: ts-shell [-h|--help] [-v|--version]
+
+Options:
+	-h, --help	Print help information, then exit.
+	-v, --version	Print version information, then exit.
+EoUsage
+}
+
+
+# list_regex_match() - Helper routine to get a list of systems that match regex
+#
+# $cfg:		Hash reference to terminal server configuration
+# $listref:	List reference to store result
+sub list_regex_match($)
+{
+	my $cfg      = shift();
+	my %uniq_sys = ();
+	my @result   = ();
+
+	return \@result if exists $cfg->{termsys}->{'[*ALL*]'};
+
+	# get a list of systems if ts shell runs unrestricted
+	foreach my $re (@{$cfg->{regex}}) {
+		foreach (grep (/$re/, keys %{$cfg->{termsys}})) {
+			$uniq_sys{$_} = 1;
+		}
+	}
+	push @result, (keys %uniq_sys);
+	return \@result;
+}
+
+# rl_cmd_completion() - Term::ReadLine completion for ts-shell commands
+#
+# $text:	Text to complete
+# $line:	Line buffer
+# $start:	offset
+#
+sub rl_cmd_completion($$$)
+{
+	my ($text, $line, $start) = @_;
+	my @cmds = qw/help version list connect terminal quit exit/;
+
+	# complete commands
+	return grep (/^$text/, @cmds) unless $start;
+
+	# complete terminal names for service and optionally for connect command
+	if ($line =~ /^(?:terminal|connect\s+\w+)\s+(?:\w+)?$/) {
+		return grep (/^$text/, @{$config{services}});
+	}
+
+	# complete systems for connect command
+	if ($line =~ /^connect\s+(\w+)?$/) {
+		my $systems = [];	# list ref for completion
+
+		# complete for simple lists
+		if (@{$config{systems}}) {
+			foreach my $sys (@{$config{systems}}) {
+				if (auth_global(\$sys, \%config) > 0) {
+					push @$systems, $sys;
+				}
+			}
+		# complete if ts shell uses regex's
+		} elsif (@{$config{regex}}) {
+			$systems = list_regex_match(\%config);
+		}
+		return grep {/^$text/} @$systems;
+	}
+	return ();
+}
+
+# start the terminal server shell
+&main();
+
+__DATA__
+__END__
+# vim: set ai noet ts=8 sw=8 tw=80:
Index: s390-tools-sles11/iucvterm/doc/Makefile
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/doc/Makefile
@@ -0,0 +1,27 @@
+#! /usr/bin/make -f
+
+include ../../common.mak
+
+MANS = iucvconn.1 iucvtty.1 ts-shell.1 hvc_iucv.9 chiucvallow.8
+
+all:
+
+check:
+
+install: install-man
+
+install-man: $(MANS)
+	for man in $(MANS); do \
+	  msection=`echo $$man |sed 's/.*\.\([1-9]\)$$/man\1/'` ; \
+	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 -D $$man $(MANDIR)/$$msection/$$man ; \
+	done
+
+clean:
+
+pdf: $(MANS)
+	for man in $(MANS); do \
+	  man -t ./$$man |ps2pdf -sPAPERSIZE=a4 - $${man}.pdf ; \
+	done
+
+
+.PHONY: install-man install clean pdf
Index: s390-tools-sles11/iucvterm/doc/ts-shell/README.ts-shell
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/doc/ts-shell/README.ts-shell
@@ -0,0 +1,126 @@
+Terminal server setup
+=====================
+
+This README file provides additional information for configuring
+a terminal server.
+
+
+
+Installation overview
+---------------------
+The s390-tools package installs the ts-shell(1) program along with
+a set of configuration files in `/etc/iucvterm`.
+
+The ts-shell program is pre-configured to connect to any other z/VM
+guest virtual machines (if the z/VM guest virtual machine has the
+respective IUCV authorizations).
+The administrator can change the ts-shell configuration to restrict
+connections to particular z/VM guest virtual machines only.
+
+There are no user authorizations by default. The administrator must
+edit `/etc/iucvterm/ts-authorization.conf` to assign authorizations.
+See the manual page for ts-shell(1) and the `authorization-sample.conf`
+file in the documentation directory for configuration examples.
+
+In addition, the documentation directory also contains the
+iucvconn_on_login sample program that is an alternative to ts-shell.
+
+
+
+
+Setup considerations for the terminal server shell (ts-shell)
+-------------------------------------------------------------
+Adding new ts-shell users
+~~~~~~~~~~~~~~~~~~~~~~~~~
+The ts-shell installation creates a system group ts-shell.
+If you intend to use ts-shell as a login shell for users, ensure that
+these users are all members of ts-shell.  To add existing users to
+group ts-shell, use +usermod -G ts-shell 'username'+.
+
+The ts-shell configuration files and `/var/log/ts-shell` are
+readable only by members of the *ts-shell* group.
+
+
+Enabling terminal session transcripts
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+ts-shell(1) can be configured to create transcripts of terminal sessions
+to particular z/VM guest virtual machines. The transcripts are written
+to log files in the `/var/log/ts-shell` directory.
+
+NOTE:	The `/var/log/ts-shell` directory permission has the
+	set-group-ID bit set. Sub-directories that are created by
+	different users will inherit the group ownership of the
+	`/var/log/ts-shell` directory.
+
+See the ts-shell(1) manual page for more information about terminal
+session transcripts.
+
+
+Setting up command completion (optional)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+*ts-shell* supports completion for commands and, if possible, for
+z/VM guest virtual machines. The completion is triggered using the
+'Tab' key. Command completion is an optional feature.
+
+To enable command completion, install one of the following Perl
+ReadLine libraries:
+
+- Term::ReadLine::Gnu
+- Term::ReadLine::Perl
+
+Check your Linux distribution for packages that provide these Perl
+ReadLine interfaces.
+
+
+
+
+Setup a terminal server using the iucvconn_on_login program
+-----------------------------------------------------------
+*iucvconn_on_login* is a sample script that uses the iucvconn(1)
+program to establish an IUCV terminal connection to a Linux
+instance that runs as z/VM guest operating system.
+
+It can be used as an alternative to set up a terminal server.
+The idea of iucvconn_on_login is to establish a terminal connection
+at login time.
+The z/VM guest virtual machine to which iucvconn_on_login will
+connect is the name of the Linux user that logs in.
+
+For example, if you log in as Linux user "lxguest1", iucvconn_on_login
+is started and establishes a terminal connection to the z/VM guest
+virtual machine lxguest1.
+
+
+Adding new users for z/VM guest virtual machines
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+To set up a terminal server using the iucvconn_on_login program,
+create a new Linux user for each z/VM guest virtual machine using
+the z/VM user ID as name. Set the login shell of those users to
+*iucvconn_on_login*.
+
+NOTE:	User names are case-sensitive in Linux.	To ensure consistency,
+	always use either lower or upper case characters for your
+	user names.
+
+To create a new user for z/VM guest virtual machine LXGUEST1
+----
+useradd -s /usr/bin/iucvconn_on_login lxguest1
+----
+
+If you log in as user 'lxguest1' on the terminal server (for example
+using ssh(1)), *iucvconn_on_login* immediately establishes the terminal
+connection to the z/VM virtual guest virtual machine 'lxguest1'.
+
+To access the default terminal ('lnxhvc0') on the Linux instance in
+z/VM guest virtual machine LXGUEST1
+----
+ssh lxguest1@terminal.server
+----
+To access the terminal 'lnxterm' on the Linux instance in
+z/VM guest virtual machine LXGUEST1
+----
+ssh -t lxguest1@terminal.server lnxterm
+----
+For ssh(1), you must use the "-t" parameter if you want to specify an
+alternate terminal identifier. The "-t" parameter ensures that ssh
+starts iucvconn_on_login on a terminal.
Index: s390-tools-sles11/iucvterm/doc/ts-shell/authorization-sample.conf
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/doc/ts-shell/authorization-sample.conf
@@ -0,0 +1,24 @@
+# Terminal server authorization configuration
+#
+# See ts-shell(1) manual page for file format.
+
+
+## Examples -- System lists
+
+# alice is authorized to connect to guest1 .. guest5
+alice = list:guest1,guest2,guest3,guest4,guest5
+
+## bob is authorized to connect to systems listed in the file "test-systems.list"
+bob = file:/etc/iucvterm/systems/test-systems.list
+
+# authorize all members of the Linux 'admins' group to connect to systems
+# listed in the file "admin-systems.list"
+@admins = file:/etc/iucvterm/groups/admin-systems.list
+
+
+## Examples -- Regular expressions
+
+# eve has authorization to connect to systems with
+#   a) names starting with 'guest', followed by exactly 2 digits
+#   b) names starting with 'lnx', followed by 5 alphanumeric characters
+eve = regex:(?:guest\d{2}|lnx\w{5})
Index: s390-tools-sles11/iucvterm/doc/ts-shell/iucvconn_on_login
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/doc/ts-shell/iucvconn_on_login
@@ -0,0 +1,35 @@
+#! /bin/sh
+#
+# iucvconn_on_login - start terminal connection at login
+#
+# Shell script to connect to a Linux guest operation system
+# using the iucvconn(1) program.
+# The z/VM guest virtual machine to which iucvconn_on_login will connect
+# is the name of the Linux user that logs in.
+#
+# Copyright IBM Corp. 2008, 2009.
+# Author: Hendrik Brueckner <brueckner@linux.vnet.ibm.com>
+#
+prog_name=`basename $0`
+guest_name=${USER:-`whoami 2>/dev/null`}
+terminal=lnxhvc0
+iucvconn=`which iucvconn 2>/dev/null`
+
+__error() {
+	printf "$prog_name: $@\n" >&2
+	exit 1
+}
+
+# check if we have been called with -c <name> to specify an alternate
+# terminal identifier. This can be used by ssh: "ssh -t guest@ts my_term"
+case "$1" in
+  -c) test -n "$2" && terminal=$2 ;;
+esac
+
+test -t 1 || __error "The $prog_name program requires a terminal to run on"
+test "x$guest_name" = x && \
+	__error "Failed to determine the target z/VM guest virtual machine"
+test -x "$iucvconn" || __error "Failed to run the 'iucvconn' program"
+
+printf "$prog_name: Connecting to $guest_name (terminal ID: $terminal)\n\n"
+exec $iucvconn $guest_name $terminal
Index: s390-tools-sles11/iucvterm/doc/ts-shell/sample-system.list
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/doc/ts-shell/sample-system.list
@@ -0,0 +1,11 @@
+# Terminal server shell -- system list
+#
+# This file lists z/VM guest virtual machines, each name on a separate line.
+# Empty lines or lines starting with '#' are ignored.
+# See ts-shell(1) for more information.
+#
+#------|<---------------------------------------------------
+LNXSYSA
+LNXSYSB
+LNXSYS01
+LNXSYS42
Index: s390-tools-sles11/iucvterm/etc/Makefile
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/etc/Makefile
@@ -0,0 +1,30 @@
+#! /usr/bin/make -f
+
+include ../../common.mak
+
+
+IUCVTERM_DIR = $(SYSCONFDIR)/iucvterm
+CONFIG_FILES = ts-shell.conf unrestricted.conf \
+               ts-authorization.conf ts-audit-systems.conf
+
+
+all:
+check:
+install: $(CONFIG_FILES)
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -d $(IUCVTERM_DIR) ; \
+	for cnf in $(CONFIG_FILES); do \
+	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 $$cnf $(IUCVTERM_DIR) ; \
+	done
+
+clean:
+	-rm -f *.o ts-shell.conf
+
+
+%: %.in
+	my_sysconf=`echo $(IUCVTERM_DIR) |sed 's#^$(INSTROOT)##'` ; \
+	cat $< \
+	  |sed -e "s#@sysconf_path@#$$my_sysconf#g" \
+	       -e 's#@S390_TOOLS_RELEASE@#$(S390_TOOLS_RELEASE)#g' \
+	> $@
+
+.PHONY: install clean perl
Index: s390-tools-sles11/iucvterm/etc/ts-audit-systems.conf
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/etc/ts-audit-systems.conf
@@ -0,0 +1,3 @@
+# List of z/VM guest virtual machines
+# for which terminal session are logged
+#
Index: s390-tools-sles11/iucvterm/etc/ts-authorization.conf
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/etc/ts-authorization.conf
@@ -0,0 +1,6 @@
+# Terminal server authorization configuration
+#
+# See ts-shell(1) manual page for file format syntax.
+#
+# See also authorization-sample.conf in the documentation directory.
+#
Index: s390-tools-sles11/iucvterm/etc/ts-shell.conf.in
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/etc/ts-shell.conf.in
@@ -0,0 +1,27 @@
+# Terminal server shell (ts-shell) configuration file
+#
+# See ts-shell(1) manual page for file format syntax.
+
+
+# System and authorization settings
+# ---------------------------------
+
+# ts-system
+#	file path to the ts-systems.conf configuration file
+ts-systems = @sysconf_path@/unrestricted.conf
+
+# ts-authorization
+#	file path to the ts-authorization.conf configuration file
+ts-authorization = @sysconf_path@/ts-authorization.conf
+
+
+# Session transcript settings
+# ---------------------------
+
+# transcript-systems
+#	file path to a list of systems for which session transcript are created
+transcript-systems = @sysconf_path@/ts-audit-systems.conf
+
+# transcript-directory
+#	directory path for saving transcripts
+transcript-directory = /var/log/ts-shell
Index: s390-tools-sles11/iucvterm/etc/unrestricted.conf
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/etc/unrestricted.conf
@@ -0,0 +1,2 @@
+# Allow connections to all z/VM guest virtual machines on this z/VM instance
+[*ALL*]
Index: s390-tools-sles11/iucvterm/include/af_iucv.h
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/include/af_iucv.h
@@ -0,0 +1,29 @@
+/*
+ * Copyright 2006 IBM Corporation
+ * IUCV protocol stack for Linux on zSeries
+ * Version 1.0
+ * Author(s): Jennifer Hunt <jenhunt@us.ibm.com>
+ *
+ */
+
+#ifndef __AFIUCV_H
+#define __AFIUCV_H
+
+#include <sys/socket.h>
+
+#ifndef AF_IUCV
+#	define AF_IUCV		32
+#	define PF_IUCV		AF_IUCV
+#endif
+
+/* IUCV socket address */
+struct sockaddr_iucv {
+	sa_family_t	siucv_family;
+	unsigned short	siucv_port;		/* Reserved */
+	unsigned int	siucv_addr;		/* Reserved */
+	char		siucv_nodeid[8];	/* Reserved */
+	char		siucv_user_id[8];	/* Guest User Id */
+	char		siucv_name[8];		/* Application Name */
+};
+
+#endif
Index: s390-tools-sles11/iucvterm/include/iucvterm/config.h
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/include/iucvterm/config.h
@@ -0,0 +1,31 @@
+/*
+ * iucvtty / iucvconn - IUCV Terminal Applications
+ *
+ * Configuration structure and command line processing function
+ *
+ * Copyright IBM Corp. 2008
+ * Author(s): Hendrik Brueckner <brueckner@linux.vnet.ibm.com>
+ */
+#ifndef __IUCVTTY_CONFIG_H_
+#define __IUCVTTY_CONFIG_H_
+
+enum iucvterm_prg {
+	PROG_IUCV_TTY  = 0,
+	PROG_IUCV_CONN = 1,
+};
+
+struct iucvtty_cfg {
+	char		client_check;	/* Flag to check for allowed clients.*/
+	char		client_re[129];	/* Regexp to match incoming clients. */
+	char		host[9];	/* IUCV target host name. */
+	char		service[9];	/* IUCV service name. */
+	char		**cmd_parms;	/* ptr to commandline parms. */
+	char		*sessionlog;	/* ptr to session log file path. */
+	unsigned char	esc_char;	/* Escape character. */
+};
+
+
+extern void parse_options(enum iucvterm_prg, struct iucvtty_cfg *,
+			  int, char **);
+
+#endif /* __IUCVTTY_CONFIG_H_ */
